package com.thomaskuenneth.artikel.ix;

import android.app.Activity;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.ClipData.Item;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

public class ClipboardDemo extends Activity {

	private static final String TAG = ClipboardDemo.class.getSimpleName();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		final EditText input = (EditText) findViewById(R.id.input);
		final ClipboardManager clipboardManager = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE);

		Button copy = (Button) findViewById(R.id.copy);
		copy.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				ClipData data = ClipData.newPlainText(
						getString(R.string.app_name), input.getText());
				clipboardManager.setPrimaryClip(data);
			}
		});

		Button paste = (Button) findViewById(R.id.paste);
		paste.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				ClipData data = clipboardManager.getPrimaryClip();
				if (data != null) {
					for (int i = 0; i < data.getItemCount(); i++) {
						Item item = data.getItemAt(i);
						Log.d(TAG, item.toString());
						if (i == 0) {
							input
									.setText(item
											.coerceToText(ClipboardDemo.this));
						}
					}
				}
			}
		});

		Button uppercase = (Button) findViewById(R.id.uppercase);
		uppercase.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				String s = input.getText().toString();
				input.setText(s.toUpperCase());
			}
		});

		Button lowercase = (Button) findViewById(R.id.lowercase);
		lowercase.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				String s = input.getText().toString();
				input.setText(s.toLowerCase());
			}
		});
	}
}